/***********************************************************************************************
*
*	void	gcvt(float fVal,char *szStr);
*	konvertiert float -> ASCII
*
***********************************************************************************************/
#include <math.h>

#define uchar unsigned char
#define DPOINT 3

code float fl_tab[6] = {
		1000.0,
		100.0,
		10.0,
		1.0,
		0.1,
		0.01
		};
	
void gcvt(float fVal,char *szStr)
{
	uchar	i;
	char	ch;
	float	f;
	bit		bLeadZero;

	// vorzeichen feststellen
	if (fVal < 0.0)
	{
		*szStr++ = '-';
		fVal = fabs(fVal);
	}


	bLeadZero = 0;
	for(i=0;i<6;i++)
	{
		// ziffer feststellen
		ch = '0';
		while(fVal >= 0.0)
		{
			f = fVal;
			fVal = fVal - fl_tab[i];
			ch++;
		}
		fVal = f;
		ch--;
		// Leading Zero unterdrueckung
		if(ch != '0') bLeadZero = 1;

		if(bLeadZero) *szStr++ = ch;
		if (i == (DPOINT-1)) bLeadZero = 1;
		// dezimal punkt ?
		if ( i == DPOINT) *szStr++ = '.';

	}
	*szStr = 0;
}
